/* Copyright (c) 2002-2012 Croteam Ltd. 
This program is free software; you can redistribute it and/or modify
it under the terms of version 2 of the GNU General Public License as published by
the Free Software Foundation


This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#include "StdH.h"

#include <Engine/Models/Normals.h>
#include <Core/Math/Functions.h>
#include <Core/Math/Vector.h>

extern FLOAT3D avGouraudNormals[MAX_GOURAUDNORMALS] = {
  FLOAT3D( 1.000000f,  0.000000f,  0.000000f),
  FLOAT3D( 0.980785f,  0.000000f,  0.195090f),
  FLOAT3D( 0.980785f,  0.195090f,  0.000000f),
  FLOAT3D( 0.923880f,  0.000000f,  0.382683f),
  FLOAT3D( 0.959683f,  0.198757f,  0.198757f),
  FLOAT3D( 0.923880f,  0.382683f,  0.000000f),
  FLOAT3D( 0.831470f,  0.000000f,  0.555570f),
  FLOAT3D( 0.890320f,  0.208847f,  0.404615f),
  FLOAT3D( 0.707107f,  0.000000f,  0.707107f),
  FLOAT3D( 0.788675f,  0.211325f,  0.577350f),
  FLOAT3D( 0.816497f,  0.408248f,  0.408248f),
  FLOAT3D( 0.831470f,  0.555570f,  0.000000f),
  FLOAT3D( 0.788675f,  0.577350f,  0.211325f),
  FLOAT3D( 0.707107f,  0.707107f,  0.000000f),
  FLOAT3D( 0.555570f,  0.000000f,  0.831470f),
  FLOAT3D( 0.577350f,  0.211325f,  0.788675f),
  FLOAT3D( 0.382683f,  0.000000f,  0.923880f),
  FLOAT3D( 0.404615f,  0.208847f,  0.890320f),
  FLOAT3D( 0.408248f,  0.408248f,  0.816497f),
  FLOAT3D( 0.195090f,  0.000000f,  0.980785f),
  FLOAT3D( 0.198757f,  0.198757f,  0.959683f),
  FLOAT3D( 0.000000f,  0.000000f,  1.000000f),
  FLOAT3D( 0.000000f,  0.195090f,  0.980785f),
  FLOAT3D( 0.000000f,  0.382683f,  0.923880f),
  FLOAT3D( 0.208847f,  0.404615f,  0.890320f),
  FLOAT3D( 0.211325f,  0.577350f,  0.788675f),
  FLOAT3D( 0.000000f,  0.555570f,  0.831470f),
  FLOAT3D( 0.000000f,  0.707107f,  0.707107f),
  FLOAT3D( 0.577350f,  0.788675f,  0.211325f),
  FLOAT3D( 0.639602f,  0.639602f,  0.426401f),
  FLOAT3D( 0.408248f,  0.816497f,  0.408248f),
  FLOAT3D( 0.639602f,  0.426401f,  0.639602f),
  FLOAT3D( 0.426401f,  0.639602f,  0.639602f),
  FLOAT3D( 0.211325f,  0.788675f,  0.577350f),
  FLOAT3D( 0.555570f,  0.831470f,  0.000000f),
  FLOAT3D( 0.404615f,  0.890320f,  0.208847f),
  FLOAT3D( 0.382683f,  0.923880f,  0.000000f),
  FLOAT3D( 0.208847f,  0.890320f,  0.404615f),
  FLOAT3D( 0.000000f,  0.831470f,  0.555570f),
  FLOAT3D( 0.000000f,  0.923880f,  0.382683f),
  FLOAT3D( 0.198757f,  0.959683f,  0.198757f),
  FLOAT3D( 0.195090f,  0.980785f,  0.000000f),
  FLOAT3D( 0.000000f,  0.980785f,  0.195090f),
  FLOAT3D( 0.000000f,  1.000000f,  0.000000f),
  FLOAT3D(-0.195090f,  0.980785f,  0.000000f),
  FLOAT3D(-0.198757f,  0.959683f,  0.198757f),
  FLOAT3D(-0.382683f,  0.923880f,  0.000000f),
  FLOAT3D(-0.208847f,  0.890320f,  0.404615f),
  FLOAT3D(-0.211325f,  0.788675f,  0.577350f),
  FLOAT3D(-0.408248f,  0.816497f,  0.408248f),
  FLOAT3D(-0.404615f,  0.890320f,  0.208847f),
  FLOAT3D(-0.555570f,  0.831470f,  0.000000f),
  FLOAT3D(-0.577350f,  0.788675f,  0.211325f),
  FLOAT3D(-0.707107f,  0.707107f,  0.000000f),
  FLOAT3D(-0.211325f,  0.577350f,  0.788675f),
  FLOAT3D(-0.208847f,  0.404615f,  0.890320f),
  FLOAT3D(-0.408248f,  0.408248f,  0.816497f),
  FLOAT3D(-0.198757f,  0.198757f,  0.959683f),
  FLOAT3D(-0.195090f,  0.000000f,  0.980785f),
  FLOAT3D(-0.382683f,  0.000000f,  0.923880f),
  FLOAT3D(-0.404615f,  0.208847f,  0.890320f),
  FLOAT3D(-0.577350f,  0.211325f,  0.788675f),
  FLOAT3D(-0.555570f,  0.000000f,  0.831470f),
  FLOAT3D(-0.707107f,  0.000000f,  0.707107f),
  FLOAT3D(-0.788675f,  0.577350f,  0.211325f),
  FLOAT3D(-0.639602f,  0.639602f,  0.426401f),
  FLOAT3D(-0.816497f,  0.408248f,  0.408248f),
  FLOAT3D(-0.426401f,  0.639602f,  0.639602f),
  FLOAT3D(-0.639602f,  0.426401f,  0.639602f),
  FLOAT3D(-0.788675f,  0.211325f,  0.577350f),
  FLOAT3D(-0.831470f,  0.555570f,  0.000000f),
  FLOAT3D(-0.890320f,  0.404615f,  0.208847f),
  FLOAT3D(-0.923880f,  0.382683f,  0.000000f),
  FLOAT3D(-0.890320f,  0.208847f,  0.404615f),
  FLOAT3D(-0.831470f,  0.000000f,  0.555570f),
  FLOAT3D(-0.923880f,  0.000000f,  0.382683f),
  FLOAT3D(-0.959683f,  0.198757f,  0.198757f),
  FLOAT3D(-0.980785f,  0.195090f,  0.000000f),
  FLOAT3D(-0.980785f,  0.000000f,  0.195090f),
  FLOAT3D(-1.000000f,  0.000000f,  0.000000f),
  FLOAT3D(-0.980785f, -0.195090f,  0.000000f),
  FLOAT3D(-0.959683f, -0.198757f,  0.198757f),
  FLOAT3D(-0.923880f, -0.382683f,  0.000000f),
  FLOAT3D(-0.890320f, -0.208847f,  0.404615f),
  FLOAT3D(-0.788675f, -0.211325f,  0.577350f),
  FLOAT3D(-0.816497f, -0.408248f,  0.408248f),
  FLOAT3D(-0.890320f, -0.404615f,  0.208847f),
  FLOAT3D(-0.831470f, -0.555570f,  0.000000f),
  FLOAT3D(-0.788675f, -0.577350f,  0.211325f),
  FLOAT3D(-0.707107f, -0.707107f,  0.000000f),
  FLOAT3D(-0.577350f, -0.211325f,  0.788675f),
  FLOAT3D(-0.404615f, -0.208847f,  0.890320f),
  FLOAT3D(-0.408248f, -0.408248f,  0.816497f),
  FLOAT3D(-0.198757f, -0.198757f,  0.959683f),
  FLOAT3D( 0.000000f, -0.195090f,  0.980785f),
  FLOAT3D( 0.000000f, -0.382683f,  0.923880f),
  FLOAT3D(-0.208847f, -0.404615f,  0.890320f),
  FLOAT3D(-0.211325f, -0.577350f,  0.788675f),
  FLOAT3D( 0.000000f, -0.555570f,  0.831470f),
  FLOAT3D( 0.000000f, -0.707107f,  0.707107f),
  FLOAT3D(-0.577350f, -0.788675f,  0.211325f),
  FLOAT3D(-0.639602f, -0.639602f,  0.426401f),
  FLOAT3D(-0.408248f, -0.816497f,  0.408248f),
  FLOAT3D(-0.639602f, -0.426401f,  0.639602f),
  FLOAT3D(-0.426401f, -0.639602f,  0.639602f),
  FLOAT3D(-0.211325f, -0.788675f,  0.577350f),
  FLOAT3D(-0.555570f, -0.831470f,  0.000000f),
  FLOAT3D(-0.404615f, -0.890320f,  0.208847f),
  FLOAT3D(-0.382683f, -0.923880f,  0.000000f),
  FLOAT3D(-0.208847f, -0.890320f,  0.404615f),
  FLOAT3D( 0.000000f, -0.831470f,  0.555570f),
  FLOAT3D( 0.000000f, -0.923880f,  0.382683f),
  FLOAT3D(-0.198757f, -0.959683f,  0.198757f),
  FLOAT3D(-0.195090f, -0.980785f,  0.000000f),
  FLOAT3D( 0.000000f, -0.980785f,  0.195090f),
  FLOAT3D( 0.000000f, -1.000000f,  0.000000f),
  FLOAT3D( 0.195090f, -0.980785f,  0.000000f),
  FLOAT3D( 0.198757f, -0.959683f,  0.198757f),
  FLOAT3D( 0.382683f, -0.923880f,  0.000000f),
  FLOAT3D( 0.208847f, -0.890320f,  0.404615f),
  FLOAT3D( 0.211325f, -0.788675f,  0.577350f),
  FLOAT3D( 0.408248f, -0.816497f,  0.408248f),
  FLOAT3D( 0.404615f, -0.890320f,  0.208847f),
  FLOAT3D( 0.555570f, -0.831470f,  0.000000f),
  FLOAT3D( 0.577350f, -0.788675f,  0.211325f),
  FLOAT3D( 0.707107f, -0.707107f,  0.000000f),
  FLOAT3D( 0.211325f, -0.577350f,  0.788675f),
  FLOAT3D( 0.208847f, -0.404615f,  0.890320f),
  FLOAT3D( 0.408248f, -0.408248f,  0.816497f),
  FLOAT3D( 0.198757f, -0.198757f,  0.959683f),
  FLOAT3D( 0.404615f, -0.208847f,  0.890320f),
  FLOAT3D( 0.577350f, -0.211325f,  0.788675f),
  FLOAT3D( 0.788675f, -0.577350f,  0.211325f),
  FLOAT3D( 0.639602f, -0.639602f,  0.426401f),
  FLOAT3D( 0.816497f, -0.408248f,  0.408248f),
  FLOAT3D( 0.426401f, -0.639602f,  0.639602f),
  FLOAT3D( 0.639602f, -0.426401f,  0.639602f),
  FLOAT3D( 0.788675f, -0.211325f,  0.577350f),
  FLOAT3D( 0.831470f, -0.555570f,  0.000000f),
  FLOAT3D( 0.890320f, -0.404615f,  0.208847f),
  FLOAT3D( 0.923880f, -0.382683f,  0.000000f),
  FLOAT3D( 0.890320f, -0.208847f,  0.404615f),
  FLOAT3D( 0.959683f, -0.198757f,  0.198757f),
  FLOAT3D( 0.980785f, -0.195090f,  0.000000f),
  FLOAT3D( 0.980785f,  0.000000f, -0.195090f),
  FLOAT3D( 0.959683f,  0.198757f, -0.198757f),
  FLOAT3D( 0.923880f,  0.000000f, -0.382683f),
  FLOAT3D( 0.890320f,  0.404615f, -0.208847f),
  FLOAT3D( 0.788675f,  0.577350f, -0.211325f),
  FLOAT3D( 0.816497f,  0.408248f, -0.408248f),
  FLOAT3D( 0.890320f,  0.208847f, -0.404615f),
  FLOAT3D( 0.831470f,  0.000000f, -0.555570f),
  FLOAT3D( 0.788675f,  0.211325f, -0.577350f),
  FLOAT3D( 0.707107f,  0.000000f, -0.707107f),
  FLOAT3D( 0.577350f,  0.788675f, -0.211325f),
  FLOAT3D( 0.404615f,  0.890320f, -0.208847f),
  FLOAT3D( 0.408248f,  0.816497f, -0.408248f),
  FLOAT3D( 0.198757f,  0.959683f, -0.198757f),
  FLOAT3D( 0.000000f,  0.923880f, -0.382683f),
  FLOAT3D( 0.208847f,  0.890320f, -0.404615f),
  FLOAT3D( 0.211325f,  0.788675f, -0.577350f),
  FLOAT3D( 0.000000f,  0.831470f, -0.555570f),
  FLOAT3D( 0.000000f,  0.707107f, -0.707107f),
  FLOAT3D( 0.577350f,  0.211325f, -0.788675f),
  FLOAT3D( 0.639602f,  0.426401f, -0.639602f),
  FLOAT3D( 0.408248f,  0.408248f, -0.816497f),
  FLOAT3D( 0.639602f,  0.639602f, -0.426401f),
  FLOAT3D( 0.426401f,  0.639602f, -0.639602f),
  FLOAT3D( 0.211325f,  0.577350f, -0.788675f),
  FLOAT3D( 0.555570f,  0.000000f, -0.831470f),
  FLOAT3D( 0.404615f,  0.208847f, -0.890320f),
  FLOAT3D( 0.382683f,  0.000000f, -0.923880f),
  FLOAT3D( 0.208847f,  0.404615f, -0.890320f),
  FLOAT3D( 0.000000f,  0.555570f, -0.831470f),
  FLOAT3D( 0.000000f,  0.382683f, -0.923880f),
  FLOAT3D( 0.198757f,  0.198757f, -0.959683f),
  FLOAT3D( 0.195090f,  0.000000f, -0.980785f),
  FLOAT3D( 0.000000f,  0.195090f, -0.980785f),
  FLOAT3D( 0.000000f,  0.000000f, -1.000000f),
  FLOAT3D(-0.198757f,  0.959683f, -0.198757f),
  FLOAT3D(-0.404615f,  0.890320f, -0.208847f),
  FLOAT3D(-0.577350f,  0.788675f, -0.211325f),
  FLOAT3D(-0.408248f,  0.816497f, -0.408248f),
  FLOAT3D(-0.208847f,  0.890320f, -0.404615f),
  FLOAT3D(-0.211325f,  0.788675f, -0.577350f),
  FLOAT3D(-0.788675f,  0.577350f, -0.211325f),
  FLOAT3D(-0.890320f,  0.404615f, -0.208847f),
  FLOAT3D(-0.816497f,  0.408248f, -0.408248f),
  FLOAT3D(-0.959683f,  0.198757f, -0.198757f),
  FLOAT3D(-0.980785f,  0.000000f, -0.195090f),
  FLOAT3D(-0.923880f,  0.000000f, -0.382683f),
  FLOAT3D(-0.890320f,  0.208847f, -0.404615f),
  FLOAT3D(-0.788675f,  0.211325f, -0.577350f),
  FLOAT3D(-0.831470f,  0.000000f, -0.555570f),
  FLOAT3D(-0.707107f,  0.000000f, -0.707107f),
  FLOAT3D(-0.211325f,  0.577350f, -0.788675f),
  FLOAT3D(-0.426401f,  0.639602f, -0.639602f),
  FLOAT3D(-0.408248f,  0.408248f, -0.816497f),
  FLOAT3D(-0.639602f,  0.639602f, -0.426401f),
  FLOAT3D(-0.639602f,  0.426401f, -0.639602f),
  FLOAT3D(-0.577350f,  0.211325f, -0.788675f),
  FLOAT3D(-0.208847f,  0.404615f, -0.890320f),
  FLOAT3D(-0.404615f,  0.208847f, -0.890320f),
  FLOAT3D(-0.555570f,  0.000000f, -0.831470f),
  FLOAT3D(-0.382683f,  0.000000f, -0.923880f),
  FLOAT3D(-0.198757f,  0.198757f, -0.959683f),
  FLOAT3D(-0.195090f,  0.000000f, -0.980785f),
  FLOAT3D(-0.959683f, -0.198757f, -0.198757f),
  FLOAT3D(-0.890320f, -0.404615f, -0.208847f),
  FLOAT3D(-0.788675f, -0.577350f, -0.211325f),
  FLOAT3D(-0.816497f, -0.408248f, -0.408248f),
  FLOAT3D(-0.890320f, -0.208847f, -0.404615f),
  FLOAT3D(-0.788675f, -0.211325f, -0.577350f),
  FLOAT3D(-0.577350f, -0.788675f, -0.211325f),
  FLOAT3D(-0.404615f, -0.890320f, -0.208847f),
  FLOAT3D(-0.408248f, -0.816497f, -0.408248f),
  FLOAT3D(-0.198757f, -0.959683f, -0.198757f),
  FLOAT3D( 0.000000f, -0.980785f, -0.195090f),
  FLOAT3D( 0.000000f, -0.923880f, -0.382683f),
  FLOAT3D(-0.208847f, -0.890320f, -0.404615f),
  FLOAT3D(-0.211325f, -0.788675f, -0.577350f),
  FLOAT3D( 0.000000f, -0.831470f, -0.555570f),
  FLOAT3D( 0.000000f, -0.707107f, -0.707107f),
  FLOAT3D(-0.577350f, -0.211325f, -0.788675f),
  FLOAT3D(-0.639602f, -0.426401f, -0.639602f),
  FLOAT3D(-0.408248f, -0.408248f, -0.816497f),
  FLOAT3D(-0.639602f, -0.639602f, -0.426401f),
  FLOAT3D(-0.426401f, -0.639602f, -0.639602f),
  FLOAT3D(-0.211325f, -0.577350f, -0.788675f),
  FLOAT3D(-0.404615f, -0.208847f, -0.890320f),
  FLOAT3D(-0.208847f, -0.404615f, -0.890320f),
  FLOAT3D( 0.000000f, -0.555570f, -0.831470f),
  FLOAT3D( 0.000000f, -0.382683f, -0.923880f),
  FLOAT3D(-0.198757f, -0.198757f, -0.959683f),
  FLOAT3D( 0.000000f, -0.195090f, -0.980785f),
  FLOAT3D( 0.198757f, -0.959683f, -0.198757f),
  FLOAT3D( 0.404615f, -0.890320f, -0.208847f),
  FLOAT3D( 0.577350f, -0.788675f, -0.211325f),
  FLOAT3D( 0.408248f, -0.816497f, -0.408248f),
  FLOAT3D( 0.208847f, -0.890320f, -0.404615f),
  FLOAT3D( 0.211325f, -0.788675f, -0.577350f),
  FLOAT3D( 0.788675f, -0.577350f, -0.211325f),
  FLOAT3D( 0.890320f, -0.404615f, -0.208847f),
  FLOAT3D( 0.816497f, -0.408248f, -0.408248f),
  FLOAT3D( 0.959683f, -0.198757f, -0.198757f),
  FLOAT3D( 0.890320f, -0.208847f, -0.404615f),
  FLOAT3D( 0.788675f, -0.211325f, -0.577350f),
  FLOAT3D( 0.211325f, -0.577350f, -0.788675f),
  FLOAT3D( 0.426401f, -0.639602f, -0.639602f),
  FLOAT3D( 0.408248f, -0.408248f, -0.816497f),
  FLOAT3D( 0.639602f, -0.639602f, -0.426401f),
  FLOAT3D( 0.639602f, -0.426401f, -0.639602f),
  FLOAT3D( 0.577350f, -0.211325f, -0.788675f),
  FLOAT3D( 0.208847f, -0.404615f, -0.890320f),
  FLOAT3D( 0.404615f, -0.208847f, -0.890320f),
  FLOAT3D( 0.198757f, -0.198757f, -0.959683f),
};

// Find nearest Gouraud normal for a vector.
INDEX GouraudNormal(const FLOAT3D &vNormal)
{
  INDEX i, besti;
  FLOAT p, bestp;
  
  // Find the Gouraud normal that makes smallest dot product with given vector
  besti = 0;
  bestp = 0.0f;

  for (i = 0; i < MAX_GOURAUDNORMALS; i++)
  {
    p = avGouraudNormals[i] % vNormal;
    if (p > bestp) {
      bestp = p;
      besti = i;
    }
  }

  return besti;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Functions dealing with 16-bit normal compression

// TODO: Add comment here
void CompressNormal_HQ(const FLOAT3D &vNormal, UBYTE &ubH, UBYTE &ubP)
{
  ANGLE h, p;

  const FLOAT &x = vNormal(1);
  const FLOAT &y = vNormal(2);
  const FLOAT &z = vNormal(3);

  // Calculate pitch
  p = ASin(y);

  // If y is near +1 or -1 - heading is irrelevant
  if (y > 0.99 || y < -0.99) {
    h = 0;
    
  // otherwise calculate heading
  } else {
    h = ATan2(-x, -z);
  }

  h = (h / 360.0f) + 0.5f;
  p = (p / 360.0f) + 0.5f;
  ASSERT(h >= 0 && h <= 1);
  ASSERT(p >= 0 && p <= 1);
  ubH = UBYTE(h * 255);
  ubP = UBYTE(p * 255);
}

// TODO: Add comment here
void DecompressNormal_HQ(FLOAT3D &vNormal, UBYTE ubH, UBYTE ubP)
{
  ANGLE h = (ubH / 255.0f) * 360.0f - 180.0f;
  ANGLE p = (ubP / 255.0f) * 180.0f - 90.0f;

  FLOAT &x = vNormal(1);
  FLOAT &y = vNormal(2);
  FLOAT &z = vNormal(3);

  x = -Sin(h)*Cos(p);
  y = Sin(p);
  z = -Cos(h)*Cos(p);
}